// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package slhdsa

import (
	"crypto/rand"

	"go.cypherpunks.su/keks/cm/sign/slhdsa/circl"
)

const (
	SLHDSASHAKE256s       = "slh-dsa-shake-256s"
	SLHDSASHAKE256sPh     = "slh-dsa-shake-256s-ph"
	SLHDSASHAKE256sMerkle = "slh-dsa-shake-256s-merkle"
)

func NewKeypair(algo string) (prv, pub []byte, err error) {
	pk, sk, err := circl.GenerateKey(rand.Reader, circl.SHAKE_256s)
	if err != nil {
		return
	}
	pub, err = pk.MarshalBinary()
	if err != nil {
		return
	}
	prv, err = sk.MarshalBinary()
	if err != nil {
		return
	}
	return
}
